Require Export PolyList.
Section list_acc.
Variables A : Set; R : A -> A ->  Prop.
 
Inductive listR : (list A) -> (list A) ->  Prop :=
  Rhd: (a, b : A) (l1 : (list A)) (R a b) ->  (listR (cons a l1) (cons b l1))
 | Rtl:
     (a : A)
     (l1, l2 : (list A)) (listR l1 l2) ->  (listR (cons a l1) (cons a l2)) .
 
Theorem AccRnil: (Acc (list A) listR (nil A)).
Apply Acc_intro.
Intros y H; Inversion H.
Qed.
 
Theorem consAcc:
 (a : A)
 (Acc A R a) ->
 (l : (list A)) (Acc (list A) listR l) ->  (Acc (list A) listR (cons a l)).
Intros a Ha; Elim Ha.
Intros x H H0 l H1; Try Assumption.
Elim H1.
Intros x0 H2 H3; Try Assumption.
Apply Acc_intro.
Intros y H4; Try Assumption.
Inversion H4; Auto with *.
Apply H0.
Try Exact H7.
Apply Acc_intro; Exact H2.
Qed.
 
Theorem accElim2:
 (P : A -> A ->  Prop)
 ((x, y : A)
  ((t : A) (R t x) ->  (P t y)) -> ((t : A) (R t y) ->  (P x t)) ->  (P x y)) ->
 (x, y : A) (Acc A R x) -> (Acc A R y) ->  (P x y).
Intros P H x y H0; Generalize y; Clear y; Elim H0.
Intros x0 H1 H2 y H3; Elim H3.
Intros x1 H4 H5.
Apply H; Auto.
Intros t H6; Apply H2; Auto.
Apply Acc_intro; Auto.
Qed.
 
Theorem accElim3:
 (P : A -> A -> A ->  Prop)
 ((x, y, z : A)
  ((t : A) (R t x) ->  (P t y z)) ->
  ((t : A) (R t y) ->  (P x t z)) ->
  ((t : A) (R t z) ->  (P x y t)) ->  (P x y z)) ->
 (x, y, z : A) (Acc A R x) -> (Acc A R y) -> (Acc A R z) ->  (P x y z).
Intros P H x y z H0; Generalize y z; Clear y z; Elim H0.
Intros x0 H1 H2 y z H3; Generalize z; Clear z; Elim H3.
Intros x1 H4 H5 z H6; Elim H6.
Intros x2 H7 H8; Apply H; Auto.
Intros t H9; Apply H2; Auto.
Apply Acc_intro; Auto.
Apply Acc_intro; Auto.
Intros t H9; Apply H5; Auto.
Apply Acc_intro; Auto.
Qed.
End list_acc.
